#include "libsprite/Wlib.h"
struct torp
{
  struct torp *next, *prev;
  int alive, frame;
  double x, y;
  double xspeed, yspeed;
  int wrap_times_left;
};

typedef struct torp torp_t;

struct star
{
    double x, y;
    double speed;
    W_Color color;
};

/*    struct cluster  */
/*    {  */
/*      struct cluster *next, *prev;  */
/*      int alive, frame;  */
/*      double x, y;  */
/*      double xspeed, yspeed;  */
/*      int wrap_times_left;  */
/*  }; */

typedef struct cluster cluster_t;

typedef struct star star_t;

enum alien_state
{
  DEAD=0,
  WAITING_TO_ENTER,
  ENTERING,
  IN_CONVOY,
  ATTACKING,
  ESCORTING,
  RETURNING_TO_CONVOY,
};

typedef enum alien_state alien_state_t;

enum weapon_type
{
  SINGLESHOT,
  DOUBLESHOT,
  TRIPLESHOT,
  QUAD_SHOT,
  Q5_SHOT,
  Q6_SHOT,
  Q7_SHOT,
  Q8_SHOT,
  Q9_SHOT,
  Q10_SHOT,
  Q11_SHOT,
  Q12_SHOT,
  Q13_SHOT,
  Q14_SHOT,
  Q15_SHOT,
 NUMWEAPONS
};
typedef enum weapon_type weapon_type_t;

struct alien
{
    double x, y;
    alien_state_t state;
    int dir;
    int steer;
    int alive;
    int dying;
    int path, path_pos;
    int escorting;
    int entering, enterdelay;
    int type;
    int id;
    W_Image *shape;
};

typedef struct alien alien_t;

struct explosion
{
    struct explosion *next, *prev;
    double x, y;
    int frame;
    W_Image *shape;
};

typedef struct explosion explosion_t;

struct score_bubble {
    struct score_bubble *next, *prev;
    double x, y;
    int count;
    W_Image *shape;
};

typedef struct score_bubble score_bubble_t;

struct player
{
  double x,y;
  double movespeed;
  double acceleration; /* not used */
  int numtorps;
  int maxtorps;
  weapon_type_t weapon;
  int cannon_power;
  int flash;
  int dead;
  int shield;
  int mouse_control;
  int ships;
  int score;
  int last_score;
  int keys;
  int next_bonus;
  int got_lemon;
  int times_torps_can_wrap;
  int safety_bubbles;
  int shoot_down_etorps;
  int torp_velocity;
  int prize_velocity;
};

typedef struct player player_t;



